/*
 * @Author: PoJun
 * @Date: 2023-05-14 18:30:03
 * @LastEditors: PoJun
 * @LastEditTime: 2023-06-26 20:03:14
 * @Message: Nothing
 */
const http = uni.$u.http;
// 根据用户code进行微信小程序登录
export const getLoginOpenId = code => http.post("/login_wechat", { code });

// 根据用户code获取用户的手机号码
export const getUserPhone = (params, config) => http.post("/userphone", params, config);

// 微信小程序登录获取用户手机号，同步建立与系统用户的绑定关系-ajax
export const loginByCode = (params, config) => http.post(`/mall_merchants/fill`, params, config);

// 获取登录信息
export const getLogInfo = config => http.get(`/logininfo`, config);

// 获取show列表
export const getShowList = (params, config = {}) => http.get("/mall_shows/list", params, config);

// 获取show详情
export const getShowInfo = (id, config = {}) => http.get(`/mall_shows/${id}/info`, config);

// 新增一个秀
export const newShowItem = (params, config = {}) => http.post(`/mall_shows/new`, params, config);

// 秀的分类编辑维护
export const showCategorys = (id, params, config = {}) => http.post(`/mall_shows/${id}/categorys`, params, config);

// 复制一个秀
export const copyShowById = (id, params, config = {}) => http.post(`/mall_shows/${id}/copyinfo`, params, config);

// 删除一个秀
export const delShowById = (id, params, config = {}) => http.post(`/mall_shows/${id}/del`, params, config);

// 秀的商品添加?
export const addGoods = (id, params, config = {}) => http.post(`/mall_shows/${id}/goods/new`, params, config);

// 秀的商品删除
export const delOneGoods = (id, goodId, params, config = {}) =>
    http.post(`/mall_shows/${id}/goods/${goodId}/del`, params, config);

// 秀的商品编辑
export const editOneGoods = (id, goodId, params, config = {}) =>
    http.post(`/mall_shows/${id}/goods/${goodId}/info`, params, config);

// 获取商品信息
export const getGoodsInfo = (id, goodId, config = {}) => http.get(`/mall_shows/${id}/goods/${goodId}/info`, config);

// 秀发布
export const publishShow = (id, params, config = {}) => http.post(`/mall_shows/${id}/publish`, params, config);

// 秀主题配置, 颜色和图片
export const setShowTopic = (id, params, config = {}) => http.post(`/mall_shows/${id}/topic`, params, config);

// 图片上传
export const spaceUpload = (params, config) => http.post("/files/uploadbase64?scope=tmp", params, config);

// 更新联系人
export const updateContact = (showId, params, config) => http.post(`/mall_shows/${showId}/contact`, params, config);
