/*
 * @Author: PoJun
 * @Date: 2023-05-14 17:52:10
 * @LastEditors: PoJun
 * @LastEditTime: 2023-06-19 14:47:37
 * @Message: Nothing
 */
import Vue from "vue";
import Vuex from "vuex";
Vue.use(Vuex);

let lifeData = {};

try {
    // 尝试获取本地是否存在lifeData变量，第一次启动APP时是不存在的
    lifeData = uni.getStorageSync("lifeData");
} catch (e) {
    console.log(e);
}

// 需要永久存储，且下次APP启动需要取出的，在state中的变量名
let saveStateKeys = [];
// 保存变量到本地存储中
const saveLifeData = function (key, value) {
    // 判断变量名是否在需要存储的数组中
    if (saveStateKeys.indexOf(key) != -1) {
        // 获取本地存储的lifeData对象，将变量添加到对象中
        let tmp = uni.getStorageSync("lifeData");
        // 第一次打开APP，不存在lifeData变量，故放一个{}空对象
        tmp = tmp ? tmp : {};
        tmp[key] = value;
        // 执行这一步后，所有需要存储的变量，都挂载在本地的lifeData对象中
        uni.setStorageSync("lifeData", tmp);
    }
};
const store = new Vuex.Store({
    state: {
        // 如果上面从本地获取的lifeData对象下有对应的属性，就赋值给state中对应的变量
        // ----加上v前缀-----，是防止变量名冲突，也让人一目了然
        vPhone: "",
        // vJWT: "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJsb2dpblR5cGUiOiJsb2dpbiIsImxvZ2luSWQiOiI5ZTVjMGE4NS0zNjQ1LTQwMzktOTJlYi1jNDZiYWUwYTFlNWEiLCJyblN0ciI6IlA0SFdrWjFNdVRSMXJMTjVscGpkMG5IVHpuYlhPeFpLIn0.MZt9bLXbqxQ3p2gCWffRCjOk5WAFwTcH9W9DvrUIL7A",
        vJWT: "",
        vAccountId: "",
        vMerchantId: "", //商戶id
        vMall_merchant_state: 1, //商户状态,0停用 1启用
    },
    mutations: {
        $uStore(state, payload) {
            // 判断是否多层级调用，state中为对象存在的情况，诸如user.info.score = 1
            let nameArr = payload.name.split(".");
            let saveKey = "";
            let len = nameArr.length;
            if (nameArr.length >= 2) {
                let obj = state[nameArr[0]];
                for (let i = 1; i < len - 1; i++) {
                    obj = obj[nameArr[i]];
                }
                obj[nameArr[len - 1]] = payload.value;
                saveKey = nameArr[0];
            } else {
                // 单层级变量，在state就是一个普通变量的情况
                state[payload.name] = payload.value;
                saveKey = payload.name;
            }
            // 保存变量到本地，见顶部函数定义
            saveLifeData(saveKey, state[saveKey]);
        },
    },
    actions: {},
});

export default store;
